#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;


void main()
{
    vec2 tx = vec2(v_texCoord.x * 2.0 - 1.0 , v_texCoord.y);
    float d = distance(vec2(abs(tx.x),tx.y),vec2(0.5,0.5));
    float b = (0.5-clamp(d,0.0,0.5))*2.0;
    
    float colEx;
    float stp;
     colEx=1.0;
     stp=step(distance(abs(tx),vec2(0.60,0.59)),0.53);
     colEx=stp*0.0+(1.0-stp)*colEx;
     stp=step(distance(abs(tx),vec2(0.75,0.50)),0.54);
     colEx=stp*1.0+(1.0-stp)*colEx;
     stp=step(distance(abs(tx),vec2(0.67,0.60)),0.48);
     colEx=stp*0.0+(1.0-stp)*colEx;

    colEx=1.0-colEx*0.2;
    float cu = 0.9*colEx;
    float cd = (0.3+0.5*tx.y)*colEx;
    float ce = cd+0.1*sin(u_time*0.09);
    vec3 c1 = vec3(cd,ce,cu);
    vec3 c2 = vec3(cu,ce,cd);

     stp = step(0.0,sign(tx.x));
    vec3 col = c1 * stp + c2 * (1.0-stp);
    float a=clamp((0.5-d)*10.0,0.0,1.0);
    col*=(sin(u_time*0.01)+1.0)*0.5*0.7+0.3;
    gl_FragColor = vec4(col,a);
    
}