#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform float a_;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

const float PI = 3.14159;


//Cӂ̃xNgxƂȂp𐳋KĕԂ
float ExAng(vec2 uv){
    float as = asin(uv.y/length(uv))*2.0/PI;
    float ang=  as * step(1.0, sign(uv.x)) 
          +(2.0-as)* (1.0-step(1.0,sign(uv.x)));
    return fract(ang*0.25);
}

vec3 convH2RGB(float H){
    vec3 rslt;
    float H360=H*360.0;
    rslt=step(  0.0,H360)*step(H360, 60.0)*vec3(              1.0,        H360/60.0,              0.0)
        +step( 60.0,H360)*step(H360,120.0)*vec3((120.0-H360)/60.0,              1.0,              0.0)
        +step(120.0,H360)*step(H360,180.0)*vec3(              0.0,              1.0,(H360-120.0)/60.0)
        +step(180.0,H360)*step(H360,240.0)*vec3(              0.0,(240.0-H360)/60.0,              1.0)
        +step(240.0,H360)*step(H360,300.0)*vec3((H360-240.0)/60.0,              0.0,              1.0)
        +step(300.0,H360)*step(H360,360.0)*vec3(              1.0,              0.0,(360.0-H360)/60.0);
    return rslt;
}

void main(){
    vec2 uv=v_texCoord;
    uv.x=uv.x*2.0-1.0;

    float d1=sin(mod(ExAng(uv)+u_time*0.1,1.0)*10.0);
     d1*=clamp(1.0-length(uv),0.0,1.0);
    float d2=sin(mod(ExAng(uv)-u_time*0.1,1.0)*2.0);
     d2*=clamp(1.0-length(uv),0.0,1.0);
    float d3=sin(mod(ExAng(uv)-u_time*0.005,1.0)*80.0);
     d3*=clamp(1.0-length(uv),0.0,1.0);

    gl_FragColor = vec4(convH2RGB(mod(length(uv)-u_time*0.2,1.0)),d1+d2)
                  +vec4(convH2RGB(length(uv)*1.0)*0.2,d3);
    gl_FragColor.a*=clamp((a_-length(uv))*3.0,0.0,1.0);
}