#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;

///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;
const float PI = 3.14159;
uniform float a_;

float ExAng(vec2 uv){
    float as = asin(uv.y/length(uv))*2.0/PI;
    float ang=  as * step(1.0, sign(uv.x)) 
          +(2.0-as)* (1.0-step(1.0,sign(uv.x)));
    return fract(ang*0.25);
}
void main(){
    vec2 uv=v_texCoord;
    uv.x=uv.x*2.0-1.0;

    float ea=(sin(ExAng(uv)*1000.0)+1.0)*0.005;
    float ea2=(sin((ExAng(uv)+u_time*1.1)*10.0)+1.0);


    float d1=length(length(uv)-mod(-u_time*0.041,1.0))-ea;
    d1=1.0-clamp(d1*8.0,0.0,1.0);
    float d2=length(length(uv)-mod(-u_time*0.015,1.0))-ea;
    d2=1.0-clamp(d2*3.0,0.0,1.0);

    gl_FragColor = vec4(vec3(1.0,1.0,0.5*ea2)*d1,d1)
                  +vec4(vec3(1.0,0.5,0.5*ea2)*d2,d2);
    gl_FragColor.a*= 1.0-length(uv);
    gl_FragColor.a*=clamp(a_-length(uv),0.0,1.0);
}